/* hrTest.c
**
** Test program for `hread.[ch]'.
**
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>

#include "mrmacs.h"
#include "exitcodes.h"
#include "vxerror.h"
#include "tools.h"

#include "hread.h"

int main (int argc, char *argv[])
{
    FILE *fp;
    int l1 = 1, l2 = 0;
    char *li;
    char *progname = strrchr (argv[0], '/');
    ifnull (progname) { progname = argv[0]; } else { ++progname; }
    if (argc < 2) {
	fprintf (stderr, "Usage: %s <file>\n", progname);
	exit (EX_USAGE);
    }
    ifnull (fp = fopen (argv[1], "r")) {
	vxerror (EX_OSERR, errno, "attempt to read `%s' failed", argv[1]);
    }
    for (;;) {
	li = hread_line (fp);
	if (!*li) { break; }
	l2 = hread_lineno();
	printf ("%.2d-%.2d: %s (%d chars)\n\n", l1, l2, li, strlen (li));
	l1 = l2 + 1;
    }
    printf ("End of header found at line %d\n", hread_lineno());
    return 0;
}
